<?php
/* SocCMS Engine
 * Дата последнего редактирования 24.10.2016
 * Модифицировал densnet
 */

$step = (isset($_GET['step'])) ? htmlspecialchars($_GET['step']) : null;

switch ($step) {
    default :

        $set['title'] = __('Выбор языка');

        include_once 'inc/head.php';
        ?>

        <div class="ui segment">
            <a class="ui label"><?= __('Выбор языка') ?></a>
            <a class="ui basic label"><?= __('Соглашение') ?></a>
            <a class="ui basic label"><?= __('Требования') ?></a>
            <a class="ui basic label"><?= __('Права доступа') ?></a>
        </div>

        <?php
        $languages = languages::getList();

        echo "<form class='ui segments' method='post' action='?step=1'>";
        echo '<div class="ui segment">';

        echo '<div class="ui form"><div class="grouped fields">';
        echo "<label>" . __('Выберите язык') . "</label>";
        foreach ($languages as $key => $l) {
            $checked = ($key == 'russian' ? " checked='checked'" : '');

            echo '<div class="field"><div class="ui radio checkbox">';
            echo "<input type='radio' name='language' value='$key'$checked />";
            echo "<label><i class='$l[icon] flag'></i> $l[enname]</label>";
            echo '</div>';
            echo '</div>';
        }
        echo '</div></div>';

        echo '</div>';

        echo '<div class="ui segment">';
        echo "<button class='ui right labeled icon basic button'><i class='mdi mdi-arrow-right-bold icon'></i> " . __('Далее') . " </button>";
        echo '</div>';

        echo '</form>';

        break;
    case '1':

        $set['title'] = __('Соглашение');

        include_once 'inc/head.php';

        if (!empty($_POST['language'])) {
            if (!languages::exists($_POST['language'])) {
                return false;
            }
        }
        $_SESSION['language'] = $_POST['language'];
        ?>

        <div class="ui segment">
            <a class="ui basic label"><?= __('Выбор языка') ?></a>
            <a class="ui label"><?= __('Соглашение') ?></a>
            <a class="ui basic label"><?= __('Требования') ?></a>
            <a class="ui basic label"><?= __('Права доступа') ?></a>
        </div>

        <div class='ui segments'>
            <div class='ui secondary segment'>Соглашение DCMS Social & D-SE</div>

            <div class='ui segment'>
                <p class="card-text">Вы устанавливаете систему управления сайтом <b>DCMS Social v<?= $set['dcms_version'] ?> beta</b>.</p>
                <p class="card-text">Модификация <b>D-SE v <?= $set['dse_version'] ?> beta</b>.</p>
                <p class="card-text">Если Вы нашли ошибку, баг или уязвимость, сообщите пожалуйста на наш <a href = 'http://dse-s.com'>форум</a>.</p>
                <p class="card-text">Свои пожелания и рекомендации, Вы можете оставить в форуме сайта разработки.</p>
                <p class="card-text">Спасибо, что Выбрали нас!!!</p>

            </div>

            <div class='ui segment'>
                <p class="card-text"> Автор модификации: densnet</p>
                <p class="card-text"><a href = 'https://vk.com/densnet'> Денис Задорожный</a></p>
                <p class="card-text"><a href="https://vk.com/dcms_dse"> Группа ВК</a></p>
            </div>
            <div class='ui segment'>
                <p class="card-text">1) Поскольку данная программа распространяется бесплатно, то никакие претензии в сторону автора не принимаются. Также этот пункт относится к случаям взломов, спама и т.д.</p>
                <p class="card-text">2) Все вопросы об установке и настройке движка направлять только на форум официального сайта.<br />
                <p class="card-text">3) Пользователь обязуется сохранять все упоминания об авторе, сайте и названии движка в коде и на страницах движка, за исключением изображений.</p>
                <p class="card-text">4) При упоминании о данной модификации на сторонних форумах необходимо ссылаться на адрес сайта (<a href="http://dse-s.com">https://dse-s.com</a>).</p>
                <p class="card-text">5) Запрещается использование пользовательских функций движка, а также отдельного кода движка в целях продажи.</p>
                <p class="card-text">6) В случае нарушения одного или нескольких пунктов данного соглашения автор имеет право обратиться к хозяину сервера (хостинга) с просьбой об удалении всех файлов движка, установленных пользователем. Если данная просьба будет проигнорирована, будут использоваться другие методы (ибо их немалое количество).</p>
            </div>
            <div class='ui segment'>
                <form action = "?step=2" method = "post">
                    <button class='ui right labeled icon basic button'><i class='mdi mdi-arrow-right-bold icon'></i> <?= __('Далее') ?> </button>
                </form>
            </div>
        </div>


        <?php
        break;

    case '2':

        $set['title'] = __('Проверка платформы');

        include_once 'inc/head.php';
        ?>


        <div class="ui segment">
            <a class="ui basic label"><?= __('Выбор языка') ?></a>
            <a class="ui basic label"><?= __('Соглашение') ?></a>
            <a class="ui label"><?= __('Требования') ?></a>
            <a class="ui basic label"><?= __('Права доступа') ?></a>
        </div>

        <div class='ui segments'>
            <div class='ui secondary segment'>Системные требования</div>

            <form method = 'post' class="ui segment" action='?step=2'>
                <button name = 'refresh' class = 'ui basic button'><span class="mdi mdi-refresh"></span> <?= __('Обновить') ?></button>
            </form>

            <div class='ui segment'>
                <?php
                require_once H . 'sys/inc/testing.php';

                if (isset($err)) {
                    if (is_array($err)) {
                        foreach ($err as $key => $value) {
                            echo "<div class = 'err'>$value</div>";
                        }
                    } else {
                        echo "<div class = 'err'>$err</div>";
                    }
                }
                ?>
            </div>

            <form action = "?step=3" class="ui segment" method = "post">
                <?php
                if (isset($err)) {
                    ?>
                    <button class='ui right labeled icon basic button'><i class='mdi mdi-arrow-right-bold icon'></i> <?= __('Пропустить шаг') ?> </button>
                    <?php
                } else {
                    ?>
                    <button class='ui right labeled icon basic button'><i class='mdi mdi-arrow-right-bold icon'></i> <?= __('Далее') ?> </button>
                    <?php
                }
                ?>
            </form>


        </div>

        <?php
        break;

    case '3':
        $set['title'] = 'DCMS Social';

        require_once 'inc/head.php';
        ?>

        <div class="ui segment">
            <a class="ui basic label"><?= __('Выбор языка') ?></a>
            <a class="ui basic label"><?= __('Соглашение') ?></a>
            <a class="ui basic label"><?= __('Требования') ?></a>
            <a class="ui label"><?= __('Права доступа') ?></a>
        </div>

        <div class='ui segments'>
            <div class='ui secondary segment'>Проверка прав доступа</div>

            <?php
            if (isset($_GET['chmod_ok'])) {
                @chmod(H . 'install/', 0777);
                @chmod(H . 'sys/ini/', 0777);
                @chmod(H . 'sys/classes/', 0777);
                @chmod(H . 'sys/inc/', 0777);
                @chmod(H . 'sys/forum/files/', 0777);
                @chmod(H . 'sys/gallery/foto/', 0777);
                @chmod(H . 'sys/gallery/48/', 0777);
                @chmod(H . 'sys/gallery/50/', 0777);
                @chmod(H . 'sys/gallery/128/', 0777);
                @chmod(H . 'sys/gallery/640/', 0777);
                @chmod(H . 'sys/obmen/files/', 0777);
                @chmod(H . 'sys/obmen/screens/14/', 0777);
                @chmod(H . 'sys/obmen/screens/48/', 0777);
                @chmod(H . 'sys/obmen/screens/128/', 0777);
                @chmod(H . 'sys/update/', 0777);
                @chmod(H . 'sys/gift/', 0777);
                @chmod(H . 'style/themes/', 0777);
                @chmod(H . 'style/smiles/', 0777);
                @chmod(H . 'sys/fnc/', 0777);
                @chmod(H . 'sys/tmp/', 0777);

                msg('Права успешно получены!');
            }
            ?>
            <div class="ui segment">
                <a href="?step=3" class = 'ui basic button'><?= __('Обновить') ?> </a>
                <a href="?step=3&amp;chmod_ok" class = 'ui teal basic button'><?= __('Получить права') ?></a>
            </div>

            <div class="ui segment">
                <?php
                require_once H . 'sys/inc/chmod_test.php';

                if (isset($err)) {
                    if (is_array($err)) {
                        foreach ($err as $key => $value) {
                            echo "<div class='label label-danger'>$value</div>\n";
                        }
                    } else {
                        echo "<div class='label label-danger'>$err</div>\n";
                    }
                }
                ?>
            </div>

            <form action = "?step=4" class="ui segment" method = "post">
                <?php
                if (isset($err)) {
                    ?>
                    <button class='ui right labeled icon basic button'><i class='mdi mdi-arrow-right-bold icon'></i> <?= __('Пропустить шаг') ?> </button>
                    <?php
                } else {
                    ?>
                    <button class='ui right labeled icon basic button'><i class='mdi mdi-arrow-right-bold icon'></i> <?= __('Далее') ?> </button>
                    <?php
                }
                ?>
            </form>

        </div>


        <?php
        break;

    case '4':
        $set['title'] = 'SocCMS Engine';

        require_once 'inc/head.php';
        ?>

        <div class="ui segment">
            <a class="ui label"><?= __('Параметры MySQL') ?></a>
            <a class="ui basic label"><?= __('Регистрация') ?></a>
            <a class="ui basic label"><?= __('Завершение') ?></a>
        </div>

        <div class='ui segments'>
            <div class='ui secondary segment'>Параметры MySQL</div>

            <form method = 'POST' class="ui segment" action = '?step=4'>
                <button class = 'ui basic button'><?= __('Обновить') ?> </button>
            </form>


            <?php
            if (isset($_SESSION['mysql_ok']) && $_SESSION['mysql_ok'] == true) {
                header("Location: ?step=5" . SID);
            } elseif (isset($_POST['host']) && isset($_POST['user']) && isset($_POST['pass']) && isset($_POST['db'])) {

                if (!($db = @mysql_connect($_POST['host'], $_POST['user'], $_POST['pass']))) {
                    $err[] = 'Невозможно подключиться к серверу ' . $_POST['host'];
                } elseif (!@mysql_select_db($_POST['db'], $db)) {
                    $err[] = 'Проверьте название базы';
                } else {
                    $set['mysql_db_name'] = $_SESSION['db'] = $_POST['db'];
                    $set['mysql_host'] = $_SESSION['host'] = $_POST['host'];
                    $set['mysql_user'] = $_SESSION['user'] = $_POST['user'];
                    $set['mysql_pass'] = $_SESSION['pass'] = $_POST['pass'];

                    mysql_query('set charset utf8mb4');
                    mysql_query('SET names utf8mb4');
                    mysql_query('set character_set_client="utf8mb4"');
                    mysql_query('set character_set_connection="utf8mb4"');
                    mysql_query('set character_set_result="utf8mb4"');

                    $db_tables = array();
                    $tab = mysql_query('SHOW TABLES FROM ' . $_SESSION['db']);
                    for ($i = 0; $i < @mysql_num_rows($tab); $i++) {
                        $db_tables[] = mysql_tablename($tab, $i);
                    }
                    $opdirtables = opendir(H . 'install/db_tables');
                    while ($filetables = readdir($opdirtables)) {
                        if (preg_match('#\.sql$#i', $filetables)) {
                            $table_name = preg_replace('#\.sql$#i', null, $filetables);
                            if (in_array($table_name, $db_tables)) {
                                if (isset($_POST['rename']) && $_POST['rename'] == 1) {
                                    mysql_query("ALTER TABLE `$table_name` RENAME `~" . $time . "_$table_name`");
                                } else {
                                    $db_not_null = true;
                                }
                            }
                        }
                    }

                    if (isset($db_not_null)) {
                        $err[] = 'В выбранной базе данных (' . $_SESSION['db'] . ') содержатся таблицы с идентичными названиями.<br /> Очистите или выберите другую базу данных.';
                    } else {

                        require_once H . 'install/inc/ver_tables.php';
                        $msg[] = "Успешно выполнено $ok_sql из $k_sql запросов";

                        $_SESSION['mysql_ok'] = true;
                    }
                }
            }

            if (isset($_SESSION['mysql_ok']) && $_SESSION['mysql_ok'] == true) {
                ?>
                <div class = 'ui segment'>
                    <div class = 'ui success message'>
                        Подключение к базе данных успешно выполнено
                    </div>
                    <?php
                    if (isset($msg)) {
                        foreach ($msg as $key => $value) {
                            echo "<div class = 'ui green basic label'>$value</div>";
                        }
                    }
                    if (isset($err)) {
                        foreach ($err as $key => $value) {
                            echo "<div class = 'ui red basic label'>$value</div>";
                        }
                    }
                    ?>

                </div>
                <form method = 'POST' class="ui segment" action = '?step=5'>
                    <button class='ui right labeled icon basic button'><i class='mdi mdi-arrow-right-bold icon'></i> <?= __('Далее') ?> </button>
                </form>
            </div>

            <?php
            require_once 'inc/foot.php';
            exit();
        } else {
            if (isset($err)) {
                foreach ($err as $key => $value) {
                    echo "<div class='ui segment'>";
                    echo "<div class = 'ui red basic label'>$value</div>";
                    echo "</div>";
                }
            }

            $out_mysql_host = output_text($set['mysql_host']);
            $out_mysql_user = output_text($set['mysql_user']);
            $out_mysql_pass = output_text($set['mysql_pass']);
            $out_mysql_db_name = output_text($set['mysql_db_name']);
            ?>

            <form method = 'post' class = 'ui segment' action = '?step=4&amp;<?= $passgen ?>'>
                <div class="ui form">
                    <input value='<?= $out_mysql_host ?>' type="text" name='host' class="form-control" style='width: 50%;' placeholder="Хост">

                    <input value='<?= $out_mysql_user ?>' type="text" name='user' class="form-control" style='width: 50%;' placeholder="Пользователь">

                    <input value='<?= $out_mysql_pass ?>' type="text" name='pass' class="form-control" style='width: 50%;' placeholder="Пароль">

                    <input value='<?= $out_mysql_db_name ?>' type="text" name='db' class="form-control" style='width: 50%;' placeholder="Имя базы">

                    <?php
                    if (isset($db_not_null)) {
                        echo "<input type='checkbox' checked='checked' name='rename' value='1' /> <label>Переименовать существующие таблицы</label><br />";
                    }
                    ?>
                </div>
                <br />

                <button class='ui right labeled icon basic button' type="submit"><i class='mdi mdi-arrow-right-bold icon'></i> <?= __('Далее') ?> </button>
            </form>

            <?php
        }


        break;

    case '5':
        $set['title'] = 'SocCMS Engine';

        require_once 'inc/head.php';
        ?>

        <div class="ui segment">
            <a class="ui basic label"><?= __('Параметры MySQL') ?></a>
            <a class="ui label"><?= __('Регистрация') ?></a>
            <a class="ui basic label"><?= __('Завершение') ?></a>
        </div>

        <div class='ui segments'>
            <div class='ui secondary segment'>Регистрация Администратора</div>

            <?php
            include_once H . 'sys/inc/shif.php';
            if (!isset($_SESSION['shif'])) {
                $_SESSION['shif'] = $passgen;
            }

            $set['shif'] = $_SESSION['shif'];

            $db = @mysql_connect($_SESSION['host'], $_SESSION['user'], $_SESSION['pass']);
            mysql_select_db($_SESSION['db'], $db);
            mysql_query('set charset utf8mb4');
            mysql_query('SET names utf8mb4');
            mysql_query('set character_set_client="utf8mb4"');
            mysql_query('set character_set_connection="utf8mb4"');
            mysql_query('set character_set_result="utf8mb4"');

            if (isset($_SESSION['adm_reg_ok']) && $_SESSION['adm_reg_ok'] == true) {
                $tmp_set['title'] = strtoupper($_SERVER['HTTP_HOST']) . ' - Главная';
                $tmp_set['mysql_host'] = $_SESSION['host'];
                $tmp_set['mysql_user'] = $_SESSION['user'];
                $tmp_set['mysql_pass'] = $_SESSION['pass'];
                $tmp_set['mysql_db_name'] = $_SESSION['db'];
                $tmp_set['shif'] = $_SESSION['shif'];

                if (save_settings($tmp_set)) {
                    unset($_SESSION['install_step'], $_SESSION['host'], $_SESSION['user'], $_SESSION['pass'], $_SESSION['db'], $_SESSION['adm_reg_ok'], $_SESSION['mysql_ok']);
                    if ($_SERVER["SERVER_ADDR"] != '127.0.0.1') {
                        delete_dir(H . 'install/');
                    }
                    header("Location: /index.php?" . SID);
                    exit;
                } else {
                    $msg['Невозможно сохранить настройки системы'];
                }
            } elseif (isset($_POST['reg'])) {
                if (!isset($_POST['nick']) || $_POST['nick'] == null) {
                    $err[] = 'Введите логин';
                } elseif (!preg_match('#^([A-zА-я0-9\-\_\ ])+$#ui', $_POST['nick'])) {
                    $err[] = 'В логине присутствуют запрещенные символы';
                } else {
                    if (utf8_strlen($_POST['nick']) < 3) {
                        $err[] = 'Логин короче 3-х символов';
                    } elseif (utf8_strlen($_POST['nick']) > 16) {
                        $err[] = 'Логин длиннее 16-ти символов';
                    } elseif (mysql_result(mysql_query("SELECT COUNT(*) FROM `user` WHERE `nick` = '" . mysql_real_escape_string($_POST['nick']) . "' LIMIT 1"), 0) != 0) {
                        $err[] = 'Выбранный логин уже занят другим пользователем';
                    } else {
                        $nick = $_POST['nick'];
                    }
                }

                if (!isset($_POST['password']) || $_POST['password'] == null) {
                    $err[] = 'Введите пароль';
                } else {
                    if (utf8_strlen($_POST['password']) < 6) {
                        $err[] = 'Пароль короче 6-ти символов';
                    } elseif (utf8_strlen($_POST['password']) > 16) {
                        $err[] = 'Пароль длиннее 16-ти символов';
                    } elseif (!isset($_POST['password_retry'])) {
                        $err[] = 'Введите подтверждение пароля';
                    } elseif ($_POST['password'] !== $_POST['password_retry']) {
                        $err[] = 'Пароли не совпадают';
                    } else {
                        $password = $_POST['password'];
                    }
                }

                if (!isset($_POST['pol']) || !is_numeric($_POST['pol']) || ($_POST['pol'] !== '0' && $_POST['pol'] !== '1')) {
                    $err[] = 'Ошибка при выборе пола';
                } else {
                    $sex = intval($_POST['pol']);
                }

                if (!isset($err)) { #если нет ошибок
                    mysql_query("INSERT INTO `user` (`nick`, `pass`, `date_reg`, `date_aut`, `date_last`, `pol`, `level`, `group_access`, `balls`, `money`, `language`) VALUES('$nick', '" . shif($password) . "', $time, $time, $time, '$pol', '4', '15', '5000', '500', '$_SESSION[language]')");
                    $user = mysql_fetch_assoc(mysql_query("SELECT * FROM `user` WHERE `nick` = '$nick' AND `pass` = '" . shif($password) . "' LIMIT 1"));

                    $q = mysql_query("SELECT `type` FROM `all_accesses`");
                    while ($ac = mysql_fetch_assoc($q)) {
                        mysql_query("INSERT INTO `user_acсess` (`id_user`, `type`) VALUES ('$user[id]','$ac[type]')");
                    }

                    /*
                      ========================================
                      Создание настроек юзера
                      ========================================
                     */

                    mysql_query("INSERT INTO `user_set` (`id_user`) VALUES ('$user[id]')");
                    mysql_query("INSERT INTO `discussions_set` (`id_user`) VALUES ('$user[id]')");
                    mysql_query("INSERT INTO `tape_set` (`id_user`) VALUES ('$user[id]')");
                    mysql_query("INSERT INTO `notification_set` (`id_user`) VALUES ('$user[id]')");

                    $_SESSION['id_user'] = $user['id'];
                    setcookie('id_user', $user['id'], time() + 60 * 60 * 24 * 365);
                    setcookie('pass', cookie_encrypt($password, $user['id']), time() + 60 * 60 * 24 * 365);

                    $_SESSION['adm_reg_ok'] = true;
                }
            }

            if (isset($_SESSION['adm_reg_ok']) && $_SESSION['adm_reg_ok'] == true) {
                echo "<div class='ui segment'>";
                echo "<div class='ui success message'>Регистрация администратора прошла успешно</div>";

                if (isset($msg)) {
                    foreach ($msg as $key => $value) {
                        echo "<div class = 'ui green basic label'>$value</div>";
                    }
                }
                echo "</div>";
                ?>
                <form action="?step=6" method="post" class="ui segment">

                    <?php
                    if (isset($err)) {
                        echo "<button class = 'btn btn-success'>Пропустить шаг</button>";
                    } else {
                        $_SESSION['message'] = __('Установка прошла успешно');

                        header("Location: ?step=6");
                        exit;
                    }
                    ?>
                </form>
                <div class = 'ui red segment'>
                    * после установки обязательно удалите папку /install/
                </div>
                <?php
            } else {

                if (isset($err)) {
                    foreach ($err as $key => $value) {
                        echo "<div class = 'ui red basic label'>$value</div>";
                    }
                }


                echo "<form action = '?step=5&amp;$passgen' class='ui segment' method = 'post'>\n";
                echo "<div class='ui form'>";
                echo "Логин (3-16 символов)<br />";
                echo "<input type='text' name = 'nick'" . ((isset($nick)) ? " value = '" . $nick . "'" : " value = ''") . " maxlength = '16' />";
                echo "Пароль (6-16 символов)<br />";
                echo "<input type = 'password'" . ((isset($password)) ? " value = '" . $password . "'" : null) . " name = 'password' maxlength = '16' />";
                echo "Подтверждение пароля<br />";
                echo "<input type = 'password'" . ((isset($password)) ? " value = '" . $password . "'" : null) . " name = 'password_retry' maxlength='16' />";
                echo "Ваш пол<br />";
                echo "<select name='pol' style='width: 50%;'>";
                echo "<option value='1'" . ((isset($pol) && $pol === 1) ? " selected='selected'" : null) . ">Мужской</option>";
                echo "<option value='0'" . ((isset($pol) && $pol === 0) ? " selected='selected'" : null) . ">Женский</option>";
                echo '</select><br /></div>';
                ?>

                <span class='tag tag-info'>* использование простого пароля облегчает жизнь хакерам</span><br />
                <span class='tag tag-info'>* Все поля обязательны к заполнению</span><br /><br />
                <button class='ui right labeled icon basic button' name='reg' type="submit"><i class='mdi mdi-arrow-right-bold icon'></i> <?= __('Зарегистрироваться') ?> </button>

            </form>
            <?php
        }

        break;

    case '6':
        if (isset($_SESSION['mysql_ok']) && $_SESSION['mysql_ok'] == true) {
            header("Location: ?step=5" . SID);
        }
        break;
}

require_once 'inc/foot.php';
